"use strict";

exports.__esModule = true;
exports.default = createCreateCreateObjectTypeMetadata;

function createCreateCreateObjectTypeMetadata(t) {
  return function createCreateObjectTypeMetadata(typeForAnnotation) {
    return function createObjectTypeMetadata(annotation) {
      var properties = annotation.properties;
      var types = annotation.types;

      if (!properties && types && types.length) {
        properties = types[types.length - 1].properties;
      }

      if (properties) {
        var props = [];

        for (var i = 0, l = properties.length; i < l; i++) {
          var property = properties[i];
          var key = property.key,
              value = property.value;

          if (!key || !value) {
            break;
          }

          var val = typeForAnnotation(value);

          if (val) {
            props.push(t.objectProperty(t.identifier(key.name), val));
          }
        }

        return t.objectExpression(props);
      }

      return t.identifier('Object');
    };
  };
}
//# sourceMappingURL=createCreateCreateObjectTypeMetadata.js.map