"use strict";

exports.__esModule = true;
exports.default = createGetUniqueTypeName;

var _path = require("path");

var escapedSep = _path.sep.replace(/[\-\[\]{}()*+?.,\\\^$|#\s]/g, '\\$&');

var IS_RELATIVE = new RegExp('\\.' + escapedSep);

function createGetUniqueTypeName(strategy) {
  function getUniqueTypeName(pathValue, name) {
    var suffix = IS_RELATIVE.test(pathValue) ? (0, _path.basename)(pathValue) : pathValue;
    return name + (suffix ? '.' + suffix : '');
  }

  function getDefaultUniqueTypeName(pathValue, name) {
    return name;
  }

  switch (strategy) {
    case 'fullPath':
      return getUniqueTypeName;

    case 'typeName':
      return getDefaultUniqueTypeName;

    default:
      return getDefaultUniqueTypeName;
  }
}
//# sourceMappingURL=createGetUniqueTypeName.js.map