"use strict";

exports.__esModule = true;
exports.default = createReplaceMagicTypeCasts;

function createReplaceMagicTypeCasts(t, externalTypeNames) {
  return function replaceMagicTypeCasts(path) {
    var node = path.node;
    var typeAnnotation = node.typeAnnotation && node.typeAnnotation.typeAnnotation;
    var id = typeAnnotation.id;
    var name = externalTypeNames.get(id.name);

    if (name) {
      path.replaceWith(t.stringLiteral(name));
    }
  };
}
//# sourceMappingURL=createReplaceMagicTypeCasts.js.map